/***************************************************************************/
/*		       _____                                               */
/*		         |    ___ ___  __  .  __                           */
/*       	         |   |__   |  |__| | |__                           */
/*    		         |   |___  |  |  \ | ___|                          */
/***************************************************************************/
/*                      PROGRAMMATO DA CATTAI MARCO                        */
/****************************************************************************/
/*		   |\_/|  __  ___  __   __   __     __                      */
/*		   |   | |  |  |  |  | |__| |_      __| | \                 */
/*		   |   | |__|  |  |__| |  \ |__    |___ |__|                */
/****************************************************************************/
 /*			         TRIPLE BUFFER				   */
 /**************************************************************************
  *									   *
  *		    	      MOTORE GRAFICO 2D				   *
  *              Libreria per la gestione della scheda VGA                 *
  *			    MODALITA' 320x200x256		   	   *
  *			       by Cattai Marco			           *
  *							    Version 2.1    *
  **************************************************************************/
#include "motore2d.h"
#include "calc.h"
#include "tastiera.h"
#include "text2.h"

/* COSTANTI */
#define MATRICEY 18
#define MATRICEX 10
#define XMIN     10
#define XMAX     100
#define YMIN     10
#define YMAX     180
#define PEZZO  "pezzo.pcx"
#define MASCHERA "mas.pcx"
#define GIOCO  "tr.pcx"
#define ANIM0  "scop0.pcx"
#define ANIM1  "scop1.pcx"
#define ANIM2  "scop2.pcx"

typedef struct top{
    char nome[14];
    int score;
    int linee;
} Header;
Header  hdr[6];


/* VARIABILI GLOBALI */
int pz;       //Pezzo Corrente
int prossimo; //Prossimo Pezzo
int linee;    //Linee Fatte
int punti;    //Punti Fatti
int puntmax;
char colore;
char nextcolor;
int ex;
//PROTOTIPI DELLE FUNZIONI
int caricamento_gioco(void);

void gioco();

int scendi();
int pezzo();
int inserisci(int x,int y,int pold);
void spostaxy(int desin);
void segira(int x,int y,int pold);
void refresh(int dela);
void refresh2();
void cancella_1();
void cadi_pezzi(int riga);
void controllo();
void pross();
void read_record();
void salva_record(void);
void ordina(void);
int charint(char num);
char intchar(int num);
int divres(int dividendo,int divisore); //resto
int divris(int dividendo,int divisore); //risultato
void classifica(void);
void modifica_nome(void);



/**************************************************/
/*  		  MATRICE DEL GIOCO               */
/**************************************************/
char matrice[MATRICEY][MATRICEX]={
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
				' ',' ',' ',' ',' ',' ',' ',' ',' ',' '
			      };
/*			         INIZIO CODICE			           */
main(void)
{
 if(caricamento_gioco()==2)return 1;
  set_vga_mode  ();

  gioco();


  set_text_mode ();
  RestoreKeyboard();
  clrscreen(virtualscreen);
  clrscreen(tempscreen);
  farfree(virtualscreen);
  farfree(tempscreen);
 return 0;
}
int caricamento_gioco(void)
{
clrscr();
 printf("\nAllocazione Memoria ....");
	 if(create_screen(2)==1)
	 {
	  printf("Error");
          return 2;
	 }
         for(int u=0;u<10;u++)
	 {
           printf(".");
          delay(100);
         }
         printf("OK");
 printf("\nCaricamanto Dati ....");
        InitTables();
	generate_fire_palette (firepal);
  for(u=0;u<4;u++)
  {
  	printf(".");
 	delay(200);
  }
        printf("OK");
 printf("\nInstallazione INTERRUPT tastiera ....");
  startkey();
  for(u=0;u<30;u++)
  {
  printf(".");
  delay(60);
  }
  printf("OK\n");
  return 1;
}




void salva_record(void)
{
FILE *stream;
   stream = fopen("mio.dat", "w+");
for(int i=0;i<6;i++)
{
for(int u=0;u<14;u++)fprintf(stream,"%c",hdr[i].nome[u]);
   fprintf(stream,"%4d%4d",hdr[i].score,hdr[i].linee);
}
   fclose(stream);
}

void read_record()
{
FILE *stream;
int c[4];
   stream = fopen("mio.dat", "rb");

for(int i=0;i<6;i++)
{
for(int u=0;u<14;u++)hdr[i].nome[u]=fgetc(stream);

for(u=0;u<4;u++)c[u]=fgetc(stream);
hdr[i].score=0;
for(u=0;u<4;u++)
if(c[u]!=32)hdr[i].score=hdr[i].score*10+(c[u]-'0');

for(u=0;u<4;u++)c[u]=fgetc(stream);
hdr[i].linee=0;
for(u=0;u<4;u++)
if(c[u]!=32)hdr[i].linee=hdr[i].linee*10+(c[u]-'0');
}
  fclose(stream);

}


void ordina(void)
{
 int comodo;
 char nome[14];

for(int i=0;i<5;i++)
	for(int j=i+1;j<6;j++)
        {
        if(hdr[i].score<hdr[j].score)
        {
         comodo=hdr[i].score;
         hdr[i].score=hdr[j].score;
         hdr[j].score=comodo;
         comodo=hdr[i].linee;
         hdr[i].linee=hdr[j].linee;
         hdr[j].linee=comodo;
	for(int v=0;v<14;v++)
        nome[v]=hdr[i].nome[v];
	for(v=0;v<14;v++)
        hdr[i].nome[v]=hdr[j].nome[v];
        for(v=0;v<14;v++)
        hdr[j].nome[v]=nome[v];
        }
        }



}







void gioco()
{
 pcx(GIOCO);

 for(int i=0;i<=30;i+=10)
 {
 yorg=15;
 xorg=129+i;
 stampa_carattere('V',10,249,virtualscreen);
 }
 yorg=15;
 xorg=159;
 stampa_carattere('0',10,249,virtualscreen);

 for(i=0;i<30;i+=10)
 {
 yorg=47;
 xorg=129+i;
 stampa_carattere('V',10,249,virtualscreen);
 }
 yorg=47;
 xorg=159;
 stampa_carattere('0',10,249,virtualscreen);


 for(i=0;i<=30;i+=10)
 {
 yorg=79;
 xorg=129+i;
 stampa_carattere('V',10,249,virtualscreen);
 }


 for(i=0;i<=30;i+=10)
 {
 yorg=110;
 xorg=129+i;
 stampa_carattere('V',10,249,virtualscreen);
 }


read_record(); //Legge i record
ordina(); //Ordina i record
int cifre;
puntmax=hdr[0].score;

		 yorg=110;
		    if(puntmax<10)cifre=1;
		    else if(puntmax<100)cifre=2;
		    else if(puntmax<1000)cifre=3;
		    else if(puntmax<10000)cifre=4;

		 if(cifre==1)xorg=159;
		 if(cifre==2)xorg=149;
		 if(cifre==3)xorg=139;
		 if(cifre==4)xorg=129;
                 wait_retrace();
		 num(puntmax,10,249,0,virtualscreen);





 	copyscr(tempscreen,virtualscreen);
        for(int e=1000;e>0;e-=10)
	{
        clrscreen(virtualscreen);
	RotateFullScreenImage(tempscreen,virtualscreen,255,e);//60
 	copyscr(physicalscreen,virtualscreen);
        }

        for(e=1;e<60;e+=10)
	{
        clrscreen(virtualscreen);
	RotateFullScreenImage(tempscreen,virtualscreen,255,e);//60
 	copyscr(physicalscreen,virtualscreen);
        }
 	copyscr(physicalscreen,tempscreen);
        clrscreen(tempscreen);
        spritebuffer(PEZZO,0,0,0,tempscreen); //Carico gli sprite nel buffer
        spritebuffer(ANIM0,0,11,0,tempscreen); //Carico gli sprite nel buffer
        spritebuffer(ANIM1,0,22,0,tempscreen); //Carico gli sprite nel buffer
        spritebuffer(ANIM2,0,33,0,tempscreen); //Carico gli sprite nel buffer

 /* --- -- - -- INIZIO GIOCO - - ---- - -*/
  int finito;
 int rows,cols;
// int cifre;
 int u=0;

 linee=0;
 finito=1;
 punti=0;
 colore=2;
 int casual;
 randomize();
 nextcolor=rand()%5;       //randomizza il prossimo colore
 nextcolor*=10;
prossimo=(rand()%7)+1;     //randomizza il prossimo pezzo
 while(finito==1)
 {
 randomize();
 colore=nextcolor;
 nextcolor=rand()%5;
 nextcolor*=10;

 u=pezzo();
 punti++;
		    if(punti<10)cifre=1;
		    else if(punti<100)cifre=2;
		    else if(punti<1000)cifre=3;
		    else if(punti<10000)cifre=4;

		 if(cifre==1)xorg=159;
		 if(cifre==2)xorg=149;
		 if(cifre==3)xorg=139;
		 if(cifre==4)xorg=129;
		 yorg=15;
                 wait_retrace();
		 num(punti,10,249,0,physicalscreen);
 controllo();
 finito=u;

 for(rows=0;rows<MATRICEX;rows++)if(matrice[0][rows]=='2')finito='0';
 }
 if(ex==1)
{

delay(500);
 	 for(rows=0;rows<MATRICEY;rows++)
		 {
		  for(cols=0;cols<MATRICEX;cols++)
		  {
			matrice[rows][cols]='1';
		  }
		 }
refresh(10);

  	copyscr(tempscreen,physicalscreen);

        for(int e=60;e>=0;e-=2)
	{
	clrscreen(virtualscreen);
	RotateFullScreenImage(tempscreen,virtualscreen,255,e);//60
	copyscr(physicalscreen,virtualscreen);
        }

        if(punti>hdr[5].score)
	{
        modifica_nome();
        pcx("classifi.pcx");
	hdr[5].score=punti;
        hdr[5].linee=linee;
        ordina();
	salva_record();
        classifica();
        }
   	copyscr(tempscreen,virtualscreen);
        for(e=0;e<=60;e+=2)
	{
	clrscreen(virtualscreen);
	RotateFullScreenImage(tempscreen,virtualscreen,255,e);//60
	copyscr(physicalscreen,virtualscreen);
        }
	copyscr(physicalscreen,tempscreen);
        while(!Keys[ESC]);
   }
}


int pezzo()
{
	pz=prossimo;
	int x,y;
	char c;
	int pold;
	int toccato;
	pold=pz;
	prossimo=(rand()%7)+1;
	pross();
	toccato=1;
	y=0;
	x=3;
	if(inserisci(x,y,pold)==1)
	{
        ex=1;
	return 1;
        }

int i=0;
int g=0;



while(toccato==1)
{
if(i==4)
{
i=0;
Keys[DESTRA]=0;
Keys[SINISTRA]=0;
}
if(g==1)
{
g=0;
//Keys[SPAZIO]=0;
delay(100);
}

	if(Keys[DESTRA])         // right arrow is down
        {
			delay(100);
			if(x<MATRICEX-4)
			x++;
			i++;
			spostaxy(0);
                        delay(90);
        }
	if(Keys[SINISTRA])          // left arrow is down
        {
			delay(100);
			if(x>0)
			x--;
			i++;
			spostaxy(1);
                        delay(90);
	}

	if(Keys[ESC])
        {
        ex=0;
 	copyscr(tempscreen,physicalscreen);

        for(int e=60;e>=0;e-=2)
	{
	clrscreen(virtualscreen);
	RotateFullScreenImage(tempscreen,virtualscreen,255,e);//60
	copyscr(physicalscreen,virtualscreen);
        }
	clrscreen(virtualscreen);
        if(punti>hdr[5].score)
	{
        modifica_nome();
        pcx("classifi.pcx");
	hdr[5].score=punti;
        hdr[5].linee=linee;
        ordina();
	salva_record();
        classifica();
	copyscr(tempscreen,virtualscreen);
        for(e=0;e<60;e+=2)
	{
	clrscreen(virtualscreen);
	RotateFullScreenImage(tempscreen,virtualscreen,255,e);//60
	copyscr(physicalscreen,virtualscreen);
        }
	copyscr(physicalscreen,tempscreen);
        while(!Keys[ESC]);
        }

        		fade_out(10);
			return 2;
        }
	if(Keys[GIU])
        {
	delay(100);
	     toccato=scendi();
        }
	if(Keys[INVIO])
        {
			if(pz==1)pold=23;
			else if(pz==23)pold=1;
			else if(pz==2)pold=8;
			else if(pz==8)pold=9;
			else if(pz==9)pold=10;
			else if(pz==10)pold=2;
			else if(pz==4)pold=11;
			else if(pz==11)pold=4;
			else if(pz==5)pold=12;
			else if(pz==12)pold=13;
			else if(pz==13)pold=14;
			else if(pz==14)pold=5;
			else if(pz==6)pold=16;
			else if(pz==16)pold=17;
			else if(pz==17)pold=18;
			else if(pz==18)pold=6;
			else if(pz==7)pold=21;
			else if(pz==21)pold=7;
			g++;
			segira(x,y,pold);
	}

        if((Keys[DESTRA]==0)&&(Keys[SINISTRA]==0))
        {
	y++;
	delay(300);
	toccato=scendi();
        }

        if((toccato==0)&&(Keys[GIU]==1))punti++;

}

int rows,cols;
		 for(rows=0;rows<MATRICEY;rows++)
		 {
		  for(cols=0;cols<MATRICEX;cols++)
		  {
			if(matrice[rows][cols]=='1')
			matrice[rows][cols]='2';
		  }
		 }


ex=1;
return 1;
}

int scendi()
{
 //DEVO CONTOLLARE SE IL PEZZO PUO' SCENDERE
 int a,b;
 int impossible;
 impossible=0;
	for(a=0;a<MATRICEY;a++)
		for(b=0;b<MATRICEX;b++)
			if((matrice[a][b]=='1')&&((matrice[a+1][b]=='2')||(a+1==MATRICEY)))
						impossible=1;
 if(impossible==0)
 {
		for(a=MATRICEY-1;a>=0;a--)
		{
			for(b=MATRICEX;b>=0;b--)
			{
				 if((matrice[a][b]=='1')||(matrice[a][b]=='R'))
				 {
				   matrice[a][b]='R';
				   matrice[a+1][b]='1';
				 }
			}
		}
		refresh(0);
		return 1;
 }
 return 0;
}


void spostaxy(int desin)
{
 int cols,rows;
 int cubi;
 cubi=0;

 if(desin==0)
 {
 for(rows=MATRICEY-1;rows>=0;rows--)
 {
	  for(cols=MATRICEX-1;cols>=0;cols--)
	  {
		if((matrice[rows][cols]=='1')&&((matrice[rows][cols+1]=='1')||(matrice[rows][cols+1]==' '))&&(cols+1<MATRICEX))
		{
		cubi++;
		}
	  }
 }
	if(cubi==4)
	{
		 for(rows=MATRICEY-1;rows>=0;rows--)
		 {
		  for(cols=MATRICEX-1;cols>=0;cols--)
		  {
			if((matrice[rows][cols]=='1')||(matrice[rows][cols]=='R'))
			{
			matrice[rows][cols]='R';
			matrice[rows][cols+1]='1';
			}
		  }
		 }
	refresh(0);
	}

 }

if(desin==1)
 {
 for(rows=0;rows<MATRICEY;rows++)
 {
	  for(cols=0;cols<MATRICEX;cols++)
	  {
		if((matrice[rows][cols]=='1')&&((matrice[rows][cols-1]=='1')||(matrice[rows][cols-1]==' '))&&(cols>0))
		{
		cubi++;
		}
	  }
 }
	if(cubi==4)
	{
		 for(rows=0;rows<MATRICEY;rows++)
		 {
		  for(cols=0;cols<MATRICEX;cols++)
		  {
			if((matrice[rows][cols]=='1')||(matrice[rows][cols]=='R'))
			{
			matrice[rows][cols]='R';
			matrice[rows][cols-1]='1';
			}
		  }
		 }
	refresh(0);
	}

 }



}



void refresh(int dela)
{
 int rows,cols;
 int xpaint,ypaint;

 xpaint=XMIN;
 ypaint=YMIN;

 for(rows=0;rows<MATRICEY;rows++)
 {
	  for(cols=0;cols<MATRICEX;cols++)
	  {
		 if(matrice[rows][cols]=='1')
		  {
			copyimm(physicalscreen,tempscreen,10,10,0+colore,0,xpaint,ypaint);
		  }
		 if(matrice[rows][cols]=='R')
		  {
			matrice[rows][cols]=' ';
			copyimm(physicalscreen,tempscreen,10,10,50,0,xpaint,ypaint);
		  }
        	  xpaint+=10;
                  delay(dela);
	  }

	  xpaint=XMIN;
	  ypaint+=10;

  }
}

int inserisci(int x,int y,int pold)
{
		if(pold==1)
		{
                if(
		(matrice[y][x]=='2')||
		(matrice[y][x+1]=='2')||
		(matrice[y][x+2]=='2')||
		(matrice[y][x+3]=='2'))return 1;

		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		matrice[y][x+3]='1';
		}
//*******************************************************
		if(pold==2)
		{
                if(
		(matrice[y][x]=='1')||
		(matrice[y][x+1]=='1')||
		(matrice[y+1][x+1]=='1')||
		(matrice[y][x+2]=='1'))return 1;

		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		matrice[y][x+2]='1';
		}
		if(pold==3)
		{
                if(
		(matrice[y][x]=='1')||
		(matrice[y][x+1]=='1')||
		(matrice[y+1][x]=='1')||
		(matrice[y+1][x+1]=='1'))return 1;

		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x]='1';
		matrice[y+1][x+1]='1';
		}
		if(pold==4)
		{
                if(
		(matrice[y][x+1]=='1')||
		(matrice[y][x+2]=='1')||
		(matrice[y+1][x]=='1')||
		(matrice[y+1][x+1]=='1'))return 1;

		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		matrice[y+1][x]='1';
		matrice[y+1][x+1]='1';
		}
		if(pold==5)
		{
                if(
		(matrice[y][x]=='1')||
		(matrice[y+1][x]=='1')||
		(matrice[y][x+1]=='1')||
		(matrice[y][x+2]=='1'))return 1;

		matrice[y][x]='1';
		matrice[y+1][x]='1';
		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		}
		if(pold==6)
		{
		if(
		(matrice[y][x]=='1')||
		(matrice[y][x+1]=='1')||
		(matrice[y][x+2]=='1')||
		(matrice[y+1][x+2]=='1'))return 1;

		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		matrice[y+1][x+2]='1';
		}

		if(pold==7)
		{
                if(
		(matrice[y][x]=='1')||
		(matrice[y][x+1]=='1')||
		(matrice[y+1][x+1]=='1')||
		(matrice[y+1][x+2]=='1'))return 1;

		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		matrice[y+1][x+2]='1';
		}



refresh(0);
return 0;
}




void segira(int x,int y,int pold)
{
if(y>0)
{
		if(pold==1)
		{
		if( ((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y][x+2]==' ')||(matrice[y][x+2]=='1'))&&((matrice[y][x+3]==' ')||(matrice[y][x+3]=='1')) )
		{
		if(x+3<MATRICEX-1)
		{
		cancella_1();
		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		matrice[y][x+3]='1';
		pz=pold;
		}
		}
		refresh(0);
		}
		if(pold==23)
		{
		if( ((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+2][x+1]==' ')||(matrice[y+2][x+1]=='1')) )
		{
		cancella_1();
		matrice[y-1][x+1]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		matrice[y+2][x+1]='1';
		pz=pold;
		}
		refresh(0);
		}

		if(pold==2)
		{
		if( ((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1'))&&((matrice[y][x+2]==' ')||(matrice[y][x+2]=='1')) )
		{
		cancella_1();
		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		matrice[y][x+2]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==8)
		{
		if( ((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1')) )
		{
		cancella_1();
		matrice[y-1][x+1]='1';
		matrice[y][x+1]='1';
		matrice[y][x]='1';
		matrice[y+1][x+1]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==9)
		{
		if( ((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y][x+2]==' ')||(matrice[y][x+2]=='1')) )
		{
		cancella_1();
		matrice[y-1][x+1]='1';
		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==10)
		{
		if( ((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+2]==' ')||(matrice[y][x+2]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1')) )
		{
		cancella_1();
		matrice[y-1][x+1]='1';
		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		matrice[y+1][x+1]='1';
		pz=pold;
		refresh(0);
		}
		}

		if(pold==4)
		{
		if( ((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y-1][x+2]==' ')||(matrice[y-1][x+2]=='1'))&&((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1')) )
		{
		cancella_1();
		matrice[y-1][x+1]='1';
		matrice[y-1][x+2]='1';
		matrice[y][x]='1';
		matrice[y][x+1]='1';
		pz=pold;
		refresh(0);
		}
		}

                if(pold==7)
		{
		if( ((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1'))&&((matrice[y][x+2]==' ')||(matrice[y][x+2]=='1'))&&((matrice[y+1][x+2]==' ')||(matrice[y+1][x+2]=='1'))&&((matrice[y+2][x+1]==' ')||(matrice[y+2][x+1]=='1')) )
		{
		cancella_1();
		matrice[y+1][x+1]='1';
		matrice[y][x+2]='1';
		matrice[y+1][x+2]='1';
		matrice[y+2][x+1]='1';
		pz=pold;
		refresh(0);
		}
       		}

                if(pold==21)
		{
		if( ((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1'))&&((matrice[y+1][x+2]==' ')||(matrice[y+1][x+2]=='1')) )
		{
		cancella_1();
		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		matrice[y+1][x+2]='1';
		pz=pold;
		refresh(0);
		}
       		}

		if(pold==11)
		{
		if( ((matrice[y-1][x]==' ')||(matrice[y-1][x]=='1'))&&((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1')) )
		{
		cancella_1();
		matrice[y-1][x]='1';
		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		pz=pold;
		refresh(0);
		}
		}

		if(pold==5)
		{
		if( ((matrice[y-1][x]==' ')||(matrice[y-1][x]=='1'))&&((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y-1][x+2]==' ')||(matrice[y-1][x+2]=='1')) )
		{
		cancella_1();
		matrice[y-1][x]='1';
		matrice[y][x]='1';
		matrice[y-1][x+1]='1';
		matrice[y-1][x+2]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==12)
		{
		if( ((matrice[y-1][x]==' ')||(matrice[y-1][x]=='1'))&&((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1')) )
		{
		cancella_1();
		matrice[y-1][x]='1';
		matrice[y-1][x+1]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==13)
		{
		if( ((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y][x+2]==' ')||(matrice[y][x+2]=='1'))&&((matrice[y-1][x+2]==' ')||(matrice[y-1][x+2]=='1')) )
		{
		cancella_1();
		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		matrice[y-1][x+2]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==14)
		{
		if( ((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+2]==' ')||(matrice[y+1][x+2]=='1')) )
		{
		cancella_1();
		matrice[y-1][x+1]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		matrice[y+1][x+2]='1';
		pz=pold;
		refresh(0);
		}
		}

		if(pold==6)
		{
		if( ((matrice[y-1][x]==' ')||(matrice[y-1][x]=='1'))&&((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y-1][x+2]==' ')||(matrice[y-1][x+2]=='1'))&&((matrice[y][x+2]==' ')||(matrice[y][x+2]=='1')) )
		{
		cancella_1();
		matrice[y-1][x]='1';
		matrice[y-1][x+1]='1';
		matrice[y-1][x+2]='1';
		matrice[y][x+2]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==16)
		{
		if( ((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1'))&&((matrice[y+1][x]==' ')||(matrice[y+1][x]=='1')) )
		{
		cancella_1();
		matrice[y-1][x+1]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		matrice[y+1][x]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==17)
		{
		if( ((matrice[y-1][x]==' ')||(matrice[y-1][x]=='1'))&&((matrice[y][x]==' ')||(matrice[y][x]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y][x+2]==' ')||(matrice[y][x+2]=='1')) )
		{
		cancella_1();
		matrice[y-1][x]='1';
		matrice[y][x]='1';
		matrice[y][x+1]='1';
		matrice[y][x+2]='1';
		pz=pold;
		refresh(0);
		}
		}
		if(pold==18)
		{
		if( ((matrice[y-1][x+1]==' ')||(matrice[y-1][x+1]=='1'))&&((matrice[y][x+1]==' ')||(matrice[y][x+1]=='1'))&&((matrice[y-1][x+2]==' ')||(matrice[y-1][x+2]=='1'))&&((matrice[y+1][x+1]==' ')||(matrice[y+1][x+1]=='1')) )
		{
		cancella_1();
		matrice[y-1][x+1]='1';
		matrice[y-1][x+2]='1';
		matrice[y][x+1]='1';
		matrice[y+1][x+1]='1';
		pz=pold;
		refresh(0);
		}
		}
}

}

void cancella_1()
{
int rows,cols;
		 for(rows=0;rows<MATRICEY;rows++)
		 {
		  for(cols=0;cols<MATRICEX;cols++)
		  {
			if(matrice[rows][cols]=='1')
			{
			matrice[rows][cols]='R';
			}
		  }
		 }
		 refresh(0);
}


void cadi_pezzi(int riga)
{
int rows,cols;
		 for(rows=riga-1;rows>=0;rows--)
		 {
		  for(cols=MATRICEX-1;cols>=0;cols--)
		  {
			if(matrice[rows][cols]=='2')
			{
			matrice[rows][cols]='R';
			matrice[rows+1][cols]='2';
			}
		  }
		 }
refresh2();
}

void refresh2()
{
 int rows,cols;
 int xpaint,ypaint;

 xpaint=XMIN;
 ypaint=YMIN;

 for(rows=0;rows<MATRICEY;rows++)
 {
	  for(cols=0;cols<MATRICEX;cols++)
	  {
		 if(matrice[rows][cols]=='2')
		  {
			copyimm(physicalscreen,tempscreen,10,10,0+colore,0,xpaint,ypaint);
		  }
		 if(matrice[rows][cols]=='R')
		  {
			matrice[rows][cols]=' ';
			copyimm(physicalscreen,tempscreen,10,10,50,0,xpaint,ypaint);
		  }

		  xpaint+=10;

	  }

	  xpaint=XMIN;
	  ypaint+=10;

  }
}

void controllo()
{
 int rows,cols;
 int conta;
 int ypaint;
 ypaint=YMAX;
 conta=0;
 int cifre;
      for(rows=MATRICEY-1;rows>=0;rows--)
      {
	  for(cols=MATRICEX-1;cols>=0;cols--)
	  {
		 if(matrice[rows][cols]=='2')
		 conta+=1;

		 if(conta==10)
		 {
		 linee++;
		 yorg=47;
		    if(linee<10)cifre=1;
		    else if(linee<100)cifre=2;
		    else if(linee<1000)cifre=3;
		    else if(linee<10000)cifre=4;

		 if(cifre==1)xorg=159;
		 if(cifre==2)xorg=149;
		 if(cifre==3)xorg=139;
		 if(cifre==4)xorg=129;
                 wait_retrace();
		 num(linee,10,249,0,physicalscreen);


		 for(int i=0;i<MATRICEX;i++)matrice[rows][i]=' ';
  		 copyimm(physicalscreen,tempscreen,100,10,0,11,10,ypaint);
		 delay(400);
  		 copyimm(physicalscreen,tempscreen,100,10,0,22,10,ypaint);
		 delay(400);
  		 copyimm(physicalscreen,tempscreen,100,10,0,33,10,ypaint);
		 cadi_pezzi(rows);
		 rows+=1;
		 conta=0;
		 ypaint+=10;
		 }
		 if(cols==0)conta=0;

	  }
	 ypaint-=10;
      }
}

void pross()
{
int x,y;
int xpaint,ypaint;
xpaint=131;
ypaint=150;


	for(y=0;y<2;y++)
	{
		for(x=0;x<5;x++)
		{
		 copyimm(physicalscreen,tempscreen,10,10,50,0,xpaint,ypaint);
		 if(xpaint==181)xpaint=131;
		 xpaint+=10;
		}
		ypaint+=10;
	}


		if(prossimo==1)
		{
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,141,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,171,150);
		}
		if(prossimo==2)
		{
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,141,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,160);
		}
		if(prossimo==3)
		{
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,160);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,160);
		}
		if(prossimo==4)
		{
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,141,160);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,160);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,150);
		}
		if(prossimo==5)
		{
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,141,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,141,160);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,150);
		}
		if(prossimo==6)
		{
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,141,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,160);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,150);
		}
          	if(prossimo==7)
		{
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,141,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,150);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,151,160);
		copyimm(physicalscreen,tempscreen,10,10,0+nextcolor,0,161,160);
		}

}



/*
	        clrscreen(virtualscreen);
		copyscr(virtualscreen,physicalscreen);
		update_last_lines ();
        	move_firealto ();
		copyscr(physicalscreen,virtualscreen);
		update_last_lines ();
		move_firealto ();
		copyscr(physicalscreen,virtualscreen);
                generate_fire_palette (firepal);
		set_palette (firepal);
		while (KeyScan!=INVIO)
		{
		update_last_lines ();
		move_firealto ();
		copyscr(physicalscreen,virtualscreen);
                }
                fade_out(10);

*/

void modifica_nome(void)
{
 int i=0;
 char c;
 fade_out(10);
 spritebuffer("entr.pcx",60,60,1,physicalscreen);
 RestoreKeyboard();

 int xa,ya;
 ya=12;
 xa=15;
 while (i!=13)
 {
 asm{
     mov ah,8
     int 21h
     cmp al,13
     jz fine
     cmp al,32
     jz ass
     cmp al,75
     jz indietro
     cmp al,'A'
     jb continua
     cmp al,'Z'
     ja continua
    }

ass:
   asm  mov c,al

   	gotoxy(xa,ya);
	printf("%c",c);
        xa++;
	hdr[5].nome[i]=c;
        i++;
	asm jmp continua

 fine:
 	for(i;i<14;i++)
	hdr[5].nome[i]=' ';
        i=13;
        asm jmp continua


indietro:
	if(i>0)
	{
	i--;
   	gotoxy(xa-1,ya);
        printf(" ");
        xa--;
        }


 continua:

 }
   startkey();
}




void classifica(void)
{
int cifre,c,a,b;

 for(int i=0;i<=30;i+=10)
 {
 yorg=52;
 xorg=179+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=78;
 xorg=179+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=98;
 xorg=179+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=118;
 xorg=179+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=138;
 xorg=179+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=158;
 xorg=179+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=52;
 xorg=251+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=78;
 xorg=251+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=98;
 xorg=251+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=118;
 xorg=251+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=138;
 xorg=251+i;
 stampa_carattere('V',10,249,virtualscreen);
 yorg=158;
 xorg=251+i;
 stampa_carattere('V',10,249,virtualscreen);
}


  yorg=52;
  		    if(hdr[0].score<10)cifre=1;
		    else if(hdr[0].score<100)cifre=2;
		    else if(hdr[0].score<1000)cifre=3;
		    else if(hdr[0].score<10000)cifre=4;
		 if(cifre==1)xorg=209;
		 if(cifre==2)xorg=199;
		 if(cifre==3)xorg=189;
		 if(cifre==4)xorg=179;
                 wait_retrace();
		 num(hdr[0].score,10,249,0,virtualscreen);
  yorg=78;
  		    if(hdr[1].score<10)cifre=1;
		    else if(hdr[1].score<100)cifre=2;
		    else if(hdr[1].score<1000)cifre=3;
		    else if(hdr[1].score<10000)cifre=4;
		 if(cifre==1)xorg=209;
		 if(cifre==2)xorg=199;
		 if(cifre==3)xorg=189;
		 if(cifre==4)xorg=179;
                 wait_retrace();
		 num(hdr[1].score,10,249,0,virtualscreen);
  yorg=98;
  		    if(hdr[2].score<10)cifre=1;
		    else if(hdr[2].score<100)cifre=2;
		    else if(hdr[2].score<1000)cifre=3;
		    else if(hdr[2].score<10000)cifre=4;
		 if(cifre==1)xorg=209;
		 if(cifre==2)xorg=199;
		 if(cifre==3)xorg=189;
		 if(cifre==4)xorg=179;
                 wait_retrace();
		 num(hdr[2].score,10,249,0,virtualscreen);
  yorg=118;
  		    if(hdr[3].score<10)cifre=1;
		    else if(hdr[3].score<100)cifre=2;
		    else if(hdr[3].score<1000)cifre=3;
		    else if(hdr[3].score<10000)cifre=4;
		 if(cifre==1)xorg=209;
		 if(cifre==2)xorg=199;
		 if(cifre==3)xorg=189;
		 if(cifre==4)xorg=179;
                 wait_retrace();
		 num(hdr[3].score,10,249,0,virtualscreen);
  yorg=138;
  		    if(hdr[4].score<10)cifre=1;
		    else if(hdr[4].score<100)cifre=2;
		    else if(hdr[4].score<1000)cifre=3;
		    else if(hdr[4].score<10000)cifre=4;
		 if(cifre==1)xorg=209;
		 if(cifre==2)xorg=199;
		 if(cifre==3)xorg=189;
		 if(cifre==4)xorg=179;
                 wait_retrace();
		 num(hdr[4].score,10,249,0,virtualscreen);
  yorg=158;
  		    if(hdr[5].score<10)cifre=1;
		    else if(hdr[5].score<100)cifre=2;
		    else if(hdr[5].score<1000)cifre=3;
		    else if(hdr[5].score<10000)cifre=4;
		 if(cifre==1)xorg=209;
		 if(cifre==2)xorg=199;
		 if(cifre==3)xorg=189;
		 if(cifre==4)xorg=179;
                 wait_retrace();
		 num(hdr[5].score,10,249,0,virtualscreen);
//*
  yorg=52;
  		    if(hdr[0].linee<10)cifre=1;
		    else if(hdr[0].linee<100)cifre=2;
		    else if(hdr[0].linee<1000)cifre=3;
		    else if(hdr[0].linee<10000)cifre=4;
		 if(cifre==1)xorg=281;
		 if(cifre==2)xorg=271;
		 if(cifre==3)xorg=261;
		 if(cifre==4)xorg=251;
                 wait_retrace();
		 num(hdr[0].linee,10,249,0,virtualscreen);
  yorg=78;
  		    if(hdr[1].linee<10)cifre=1;
		    else if(hdr[1].linee<100)cifre=2;
		    else if(hdr[1].linee<1000)cifre=3;
		    else if(hdr[1].linee<10000)cifre=4;
		 if(cifre==1)xorg=281;
		 if(cifre==2)xorg=271;
		 if(cifre==3)xorg=261;
		 if(cifre==4)xorg=251;
                 wait_retrace();
		 num(hdr[1].linee,10,249,0,virtualscreen);
  yorg=98;
  		    if(hdr[2].linee<10)cifre=1;
		    else if(hdr[2].linee<100)cifre=2;
		    else if(hdr[2].linee<1000)cifre=3;
		    else if(hdr[2].linee<10000)cifre=4;
		 if(cifre==1)xorg=281;
		 if(cifre==2)xorg=271;
		 if(cifre==3)xorg=261;
		 if(cifre==4)xorg=251;
                 wait_retrace();
		 num(hdr[2].linee,10,249,0,virtualscreen);
  yorg=118;
  		    if(hdr[3].linee<10)cifre=1;
		    else if(hdr[3].linee<100)cifre=2;
		    else if(hdr[3].linee<1000)cifre=3;
		    else if(hdr[3].linee<10000)cifre=4;
		 if(cifre==1)xorg=281;
		 if(cifre==2)xorg=271;
		 if(cifre==3)xorg=261;
		 if(cifre==4)xorg=251;
                 wait_retrace();
		 num(hdr[3].linee,10,249,0,virtualscreen);
  yorg=138;
  		    if(hdr[4].linee<10)cifre=1;
		    else if(hdr[4].linee<100)cifre=2;
		    else if(hdr[4].linee<1000)cifre=3;
		    else if(hdr[4].linee<10000)cifre=4;
		 if(cifre==1)xorg=281;
		 if(cifre==2)xorg=271;
		 if(cifre==3)xorg=261;
		 if(cifre==4)xorg=251;
                 wait_retrace();
		 num(hdr[4].linee,10,249,0,virtualscreen);
  yorg=158;
  		    if(hdr[5].linee<10)cifre=1;
		    else if(hdr[5].linee<100)cifre=2;
		    else if(hdr[5].linee<1000)cifre=3;
		    else if(hdr[5].linee<10000)cifre=4;
		 if(cifre==1)xorg=281;
		 if(cifre==2)xorg=271;
		 if(cifre==3)xorg=261;
		 if(cifre==4)xorg=251;
                 wait_retrace();
		 num(hdr[5].linee,10,249,0,virtualscreen);

yo=60;
xo=52;
 for(b=0;b<14;b++)
 {
 yo=60;
 stmp_carattere(hdr[0].nome[b],112);
 xo+=1;
 }
yo=80;
xo=52;
 for(b=0;b<14;b++)
 {
 yo=80;
 stmp_carattere(hdr[1].nome[b],112);
 xo+=1;
 }
yo=100;
xo=52;
 for(b=0;b<14;b++)
 {
 yo=100;
 stmp_carattere(hdr[2].nome[b],112);
 xo+=1;
 }
yo=120;
xo=52;
 for(b=0;b<14;b++)
 {
 yo=120;
 stmp_carattere(hdr[3].nome[b],112);
 xo+=1;
 }
yo=140;
xo=52;
 for(b=0;b<14;b++)
 {
 yo=140;
 stmp_carattere(hdr[4].nome[b],112);
 xo+=1;
 }
yo=160;
xo=52;
 for(b=0;b<14;b++)
 {
 yo=160;
 stmp_carattere(hdr[5].nome[b],112);
 xo+=1;
 }




}

